// This file is part of the "Erik+2" program
/*
This code has been written by M. Casanellas and J. Fernandez-Sanchez. 
Please quote the paper "Invariant versus classical quartet inference when evolution is heterogeneous across sites and lineages", Sys. Bio. doi:10.1093/sysbio/syv086 .
*/

#if ! defined (ALIGNUTILS_H) 
#define ALIGNUTILS_H

#include "typedefs.h"
#include <string>
#include <fstream>
#include <cmath>
#include <cstdio>
#include <sstream>
#include <armadillo>

using namespace arma;

struct Alignment {
	unsigned int num_taxa;
	unsigned int seq_len;
	vector<string> taxa; // the taxa names
  map<string,string> seqs;  // the sequences
};


// FUNCTIONS.CPP

vector<int> get_species();
mat Flattening(map<string,int> tensor, vector<int> split, vector <int> othersp);
map<string, int> Getcolumns (Alignment &align);
vector<long int> Decomp(string it, vector <int> split, vector <int> othersp) ;
Alignment readFASTA (string fname);
vector<string> makepatterns(vector<string> &patterns);
vector<string> createpatterns(int n);
float Erik2(mat flat, int n_partitions, vector<int> split, vector<int> count_split);
string convertInt(int number);
float Erik2_swofford(mat flat, int n_partitions, vector<int> split, vector<int> count_split);


#endif

